// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <stdlib.h>
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>

// funkcie pre pracu s FrustumCulling
#include "glFrustum.h"

// .h subor
#include "OctTree.h"

FrustumCulling m_FCull;

// konstruktor *************************************************************
OctTree::OctTree()
{
 oct_tree=NULL; // rodicovsky list oktanoveho stromu
}

// destruktor **************************************************************
OctTree::~OctTree()
{
 Otree_destroy(); // zrusenie oktanoveho stromu
}

// pridanie listu do oktanoveho stromu *************************************
int OctTree::node_add(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node_level==2) { node_level--; return(0); }

 // predna cast ------------------------------------------------------------

 // lava dolna kocka           // zistenie, kolko RAM zaberie strom
 node->node[0]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[0]==NULL) {
  fprintf(stderr,"Error allocating memory for node0!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=node->minx; x2=(node->maxx-node->minx)/2.0f;
 y1=node->miny; y2=(node->maxy-node->miny)/2.0f;
 z1=node->minz; z2=(node->maxz-node->minz)/2.0f;
 node->node[0]->minx=x1; node->node[0]->maxx=x1+x2;
 node->node[0]->miny=y1; node->node[0]->maxy=y1+y2;
 node->node[0]->minz=z1; node->node[0]->maxz=z1+z2;
 //fprintf(stderr,"adding list front left down\n");
 for (a=0;a<8;a++) node->node[0]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[0]->node_tris=NULL; // list zatial nema ziadne trojuholniky
 node->node[0]->node_tris_num=0;
 node_add(node->node[0]);

 // prava dolna kocka          // zistenie, kolko RAM zaberie strom
 node->node[1]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[1]==NULL) {
  fprintf(stderr,"Error allocating memory for node1!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=(node->maxx-node->minx)/2.0f; x2=node->maxx;
 y1=node->miny;                   y2=(node->maxy-node->miny)/2.0f;
 z1=node->minz;                   z2=(node->maxz-node->minz)/2.0f;
 node->node[1]->minx=x2-x1; node->node[1]->maxx=x2;
 node->node[1]->miny=y1;    node->node[1]->maxy=y1+y2;
 node->node[1]->minz=z1;    node->node[1]->maxz=z1+z2;
 //fprintf(stderr,"adding list front right down\n");
 for (a=0;a<8;a++) node->node[1]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[1]->node_tris=NULL; // list zatial nema ziadne trojuholniky
 node->node[1]->node_tris_num=0;
 node_add(node->node[1]);

 // prava horna kocka          // zistenie, kolko RAM zaberie strom
 node->node[2]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[2]==NULL) {
  fprintf(stderr,"Error allocating memory for node2!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=(node->maxx-node->minx)/2.0f; x2=node->maxx;
 y1=(node->maxy-node->miny)/2.0f; y2=node->maxy;
 z1=node->minz;                   z2=(node->maxz-node->minz)/2.0f;
 node->node[2]->minx=x2-x1; node->node[2]->maxx=x2;
 node->node[2]->miny=y2-y1; node->node[2]->maxy=y2;
 node->node[2]->minz=z1;    node->node[2]->maxz=z1+z2;
 //fprintf(stderr,"adding list front right up\n");
 for (a=0;a<8;a++) node->node[2]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[2]->node_tris=NULL; // list zatial nema ziadne trojuholniky
 node->node[2]->node_tris_num=0;
 node_add(node->node[2]);

 // lava horna kocka           // zistenie, kolko RAM zaberie strom
 node->node[3]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[3]==NULL) {
  fprintf(stderr,"Error allocating memory for node3!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=node->minx;                   x2=(node->maxx-node->minx)/2.0f;
 y1=(node->maxy-node->miny)/2.0f; y2=node->maxy;
 z1=node->minz;                   z2=(node->maxz-node->minz)/2.0f;
 node->node[3]->minx=x1;    node->node[3]->maxx=x1+x2;
 node->node[3]->miny=y2-y1; node->node[3]->maxy=y2;
 node->node[3]->minz=z1;    node->node[3]->maxz=z1+z2;
 //fprintf(stderr,"adding list front left up\n");
 for (a=0;a<8;a++) node->node[3]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[3]->node_tris=NULL; // list zatial nema ziadne trojuholniky
 node->node[3]->node_tris_num=0;
 node_add(node->node[3]);

 // zadna cast -------------------------------------------------------------

 // lava dolna kocka           // zistenie, kolko RAM zaberie strom
 node->node[4]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[4]==NULL) {
  fprintf(stderr,"Error allocating memory for node4!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=node->minx;                   x2=(node->maxx-node->minx)/2.0f;
 y1=node->miny;                   y2=(node->maxy-node->miny)/2.0f;
 z1=(node->maxz-node->minz)/2.0f; z2=node->maxz;
 node->node[4]->minx=x1; node->node[4]->maxx=x1+x2;
 node->node[4]->miny=y1; node->node[4]->maxy=y1+y2;
 node->node[4]->minz=z2-z1; node->node[4]->maxz=z2;
 //fprintf(stderr,"adding list back left down\n");
 for (a=0;a<8;a++) node->node[4]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[4]->node_tris=NULL; // list zatial nema ziadne trojuholniky
 node->node[4]->node_tris_num=0;
 node_add(node->node[4]);

 // prava dolna kocka          // zistenie, kolko RAM zaberie strom
 node->node[5]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[5]==NULL) {
  fprintf(stderr,"Error allocating memory for node5!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=(node->maxx-node->minx)/2.0f; x2=node->maxx;
 y1=node->miny;                   y2=(node->maxy-node->miny)/2.0f;
 z1=(node->maxz-node->minz)/2.0f; z2=node->maxz;
 node->node[5]->minx=x2-x1; node->node[5]->maxx=x2;
 node->node[5]->miny=y1;    node->node[5]->maxy=y1+y2;
 node->node[5]->minz=z2-z1; node->node[5]->maxz=z2;
 //fprintf(stderr,"adding list back right down\n");
 for (a=0;a<8;a++) node->node[5]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[5]->node_tris=NULL; // list zatial nema ziadne trojuholniky
 node->node[5]->node_tris_num=0;
 node_add(node->node[5]);

 // prava horna kocka          // zistenie, kolko RAM zaberie strom
 node->node[6]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[6]==NULL) {
  fprintf(stderr,"Error allocating memory for node6!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=(node->maxx-node->minx)/2.0f; x2=node->maxx;
 y1=(node->maxy-node->miny)/2.0f; y2=node->maxy;
 z1=(node->maxz-node->minz)/2.0f; z2=node->maxz;
 node->node[6]->minx=x2-x1; node->node[6]->maxx=x2;
 node->node[6]->miny=y2-y1; node->node[6]->maxy=y2;
 node->node[6]->minz=z2-z1; node->node[6]->maxz=z2;
 //fprintf(stderr,"adding list back right up\n");
 for (a=0;a<8;a++) node->node[6]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[6]->node_tris=NULL; // list zatial nema ziadne trojuholniky
 node->node[6]->node_tris_num=0;
 node_add(node->node[6]);

 // lava horna kocka           // zistenie, kolko RAM zaberie strom
 node->node[7]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[7]==NULL) {
  fprintf(stderr,"Error allocating memory for node7!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=node->minx;                   x2=(node->maxx-node->minx)/2.0f;
 y1=(node->maxy-node->miny)/2.0f; y2=node->maxy;
 z1=(node->maxz-node->minz)/2.0f; z2=node->maxz;
 node->node[7]->minx=x1;    node->node[7]->maxx=x1+x2;
 node->node[7]->miny=y2-y1; node->node[7]->maxy=y2;
 node->node[7]->minz=z2-z1; node->node[7]->maxz=z2;
 //fprintf(stderr,"adding list back left up\n");
 for (a=0;a<8;a++) node->node[7]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[7]->node_tris=NULL; // list zatial nema ziadne trojuholniky
 node->node[7]->node_tris_num=0;
 node_add(node->node[7]);

 node_level--; return(0);
}

// vytvorenie oktanoveho stromu ********************************************
int OctTree::Otree_create(GLfloat *vert,GLuint all_tris_num)
{
 tris_array=vert;       // prevzatie pola vrcholov trojuholnikov
 tris_num=all_tris_num; // prevzatie poctu trojuholnikov

 oct_tree=new _tree_node; // vytvorenie rodicovskeho listu oktanoveho stromu
 if (oct_tree==NULL) {
  fprintf(stderr,"Error allocating memory for main node!\n"); return(1);
 }

 alloc_mem=0; alloc_mem+=sizeof(_tree_node); // zistenie, kolko RAM zaberie strom

 oct_tree->minx=0; oct_tree->maxx=0;
 oct_tree->miny=0; oct_tree->maxy=0;
 oct_tree->minz=0; oct_tree->maxz=0;
 b=0;
 for (a=0;a<tris_num;a++) {
  // najdenie najmensieho vrcholu vsetkych trojuholnikov
  if (*(tris_array+b)  <oct_tree->minx) oct_tree->minx=*(tris_array+b);
  if (*(tris_array+b+3)<oct_tree->minx) oct_tree->minx=*(tris_array+b+3);
  if (*(tris_array+b+6)<oct_tree->minx) oct_tree->minx=*(tris_array+b+6);

  if (*(tris_array+b+1)<oct_tree->miny) oct_tree->miny=*(tris_array+b+1);
  if (*(tris_array+b+4)<oct_tree->miny) oct_tree->miny=*(tris_array+b+4);
  if (*(tris_array+b+7)<oct_tree->miny) oct_tree->miny=*(tris_array+b+7);

  if (*(tris_array+b+2)<oct_tree->minz) oct_tree->minz=*(tris_array+b+2);
  if (*(tris_array+b+5)<oct_tree->minz) oct_tree->minz=*(tris_array+b+5);
  if (*(tris_array+b+8)<oct_tree->minz) oct_tree->minz=*(tris_array+b+8);

  // najdenie najvacsieho vrcholu vsetkych trojuholnikov
  if (*(tris_array+b)  >oct_tree->maxx) oct_tree->maxx=*(tris_array+b);
  if (*(tris_array+b+3)>oct_tree->maxx) oct_tree->maxx=*(tris_array+b+3);
  if (*(tris_array+b+6)>oct_tree->maxx) oct_tree->maxx=*(tris_array+b+6);

  if (*(tris_array+b+1)>oct_tree->maxy) oct_tree->maxy=*(tris_array+b+1);
  if (*(tris_array+b+4)>oct_tree->maxy) oct_tree->maxy=*(tris_array+b+4);
  if (*(tris_array+b+7)>oct_tree->maxy) oct_tree->maxy=*(tris_array+b+7);

  if (*(tris_array+b+2)>oct_tree->maxz) oct_tree->maxz=*(tris_array+b+2);
  if (*(tris_array+b+5)>oct_tree->maxz) oct_tree->maxz=*(tris_array+b+5);
  if (*(tris_array+b+8)>oct_tree->maxz) oct_tree->maxz=*(tris_array+b+8);

  b+=9;
 }
 // vsetky podlisty budu zatial prazdne
 for (a=0;a<8;a++) oct_tree->node[a]=NULL;
 // rodicovsky list nema ziadne trojuholniky
 oct_tree->node_tris=NULL;
 oct_tree->node_tris_num=0;

 node_level=0; node_add(oct_tree); // zaradenie podlistov do stromu

 fprintf(stderr,"total allocated memory for OctTree: %u\n",alloc_mem);

 free_mem=0; // moze dost k uvolneniu prazdnych listov
 node_level=0; tris_add(oct_tree); // zaradenie trojuholnikov do listov (na poslednu uroven)

 fprintf(stderr,"memory deleted by empty OctTree nodes: %u\n",free_mem);

 return(0);
}

// rekurzivne vykreslenie oktanoveho stromu ********************************
int OctTree::node_draw(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node!=NULL) {
  if (node->node_draw_bit==1) {
   // predna stena
   glBegin(GL_LINE_LOOP);
    glVertex3f(node->minx,node->miny,node->minz);
    glVertex3f(node->maxx,node->miny,node->minz);
    glVertex3f(node->maxx,node->maxy,node->minz);
    glVertex3f(node->minx,node->maxy,node->minz);
   glEnd();
   // zadna stena
   glBegin(GL_LINE_LOOP);
    glVertex3f(node->minx,node->miny,node->maxz);
    glVertex3f(node->maxx,node->miny,node->maxz);
    glVertex3f(node->maxx,node->maxy,node->maxz);
    glVertex3f(node->minx,node->maxy,node->maxz);
   glEnd();
   // spojovacie ciary
   glBegin(GL_LINES);
    // lava dolna
    glVertex3f(node->minx,node->miny,node->minz);
    glVertex3f(node->minx,node->miny,node->maxz);
    // prava dolna
    glVertex3f(node->maxx,node->miny,node->minz);
    glVertex3f(node->maxx,node->miny,node->maxz);
    // prava horna
    glVertex3f(node->maxx,node->maxy,node->minz);
    glVertex3f(node->maxx,node->maxy,node->maxz);
    // lava horna
    glVertex3f(node->minx,node->maxy,node->minz);
    glVertex3f(node->minx,node->maxy,node->maxz);
   glEnd();
  }
 }

 if (node_level==2) { node_level--; return(0); } // vykreslia sa vsetky listy po uroven

 node_level++; node_draw(node->node[0]);
 node_level++; node_draw(node->node[1]);
 node_level++; node_draw(node->node[2]);
 node_level++; node_draw(node->node[3]);
 node_level++; node_draw(node->node[4]);
 node_level++; node_draw(node->node[5]);
 node_level++; node_draw(node->node[6]);
 node_level++; node_draw(node->node[7]);

 node_level--; return(0);
}

// vykreslenie oktanoveho stromu *******************************************
void OctTree::Otree_draw()
{
 glPushAttrib(GL_LIGHTING_BIT|GL_DEPTH_BUFFER_BIT);
 glDisable(GL_LIGHTING);
 glDisable(GL_DEPTH_TEST);
 glColor4f(1.0f,1.0f,0.0f,1.0f);

 node_level=0; node_draw(oct_tree);

 glPopAttrib();
}

// zrusenie listov oktanoveho stromu ***************************************
int OctTree::node_del(_tree_node *node) // rekurzivna funkcia!!!
{
 if ((node_level==del_level)&&(node!=NULL)) {       // rusi sa konkretny level
  if (node->node_tris!=NULL) free(node->node_tris); // zrusi sa pole trojuholnikov
  delete[] node;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
  //fprintf(stderr,"deleting node: %u\n",node_level);
  node_level--; return(0);
 }

 if (node_level==2) { node_level--; return(0); }

 node_level++; node_del(node->node[0]);
 node_level++; node_del(node->node[1]);
 node_level++; node_del(node->node[2]);
 node_level++; node_del(node->node[3]);
 node_level++; node_del(node->node[4]);
 node_level++; node_del(node->node[5]);
 node_level++; node_del(node->node[6]);
 node_level++; node_del(node->node[7]);

 node_level--; return(0);
}

// zrusenie oktanoveho stromu **********************************************
int OctTree::Otree_destroy()
{
 free_mem=0;

 node_level=0; del_level=2; node_del(oct_tree); // zrusenie vsetkych listov level2
 node_level=0; del_level=1; node_del(oct_tree); // zrusenie vsetkych listov level1

 // zrusenie rodicovskeho listu oktanoveho stromu
 if (oct_tree!=NULL) {
  if (oct_tree->node_tris!=NULL) free(oct_tree->node_tris); // zrusi sa pole trojuholnikov
  delete[] oct_tree; oct_tree=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }

 fprintf(stderr,"total deleted memory for OctTree: %u\n",free_mem);

 return(0);
}

// pridanie trojuholnikov do listov oktanoveho stromu **********************
int OctTree::tris_add(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node_level==2) { // pridava sa iba do poslednej urovne
  node->node_tris_num=0; // spocitanie poctu trojuholnikov listu
  b=0;
  for (a=0;a<tris_num;a++) {
   c=0;
   // zistenie, ci je trojuholnik aspon 1 vrcholom v liste
   // test x hodnot vrcholov
   if (((*(tris_array+b)  >=node->minx)&&(*(tris_array+b)  <=node->maxx))||
       ((*(tris_array+b+3)>=node->minx)&&(*(tris_array+b+3)<=node->maxx))||
       ((*(tris_array+b+6)>=node->minx)&&(*(tris_array+b+6)<=node->maxx))) c=1;
   // test y hodnot vrcholov
   if (c==1) {
    if (((*(tris_array+b+1)>=node->miny)&&(*(tris_array+b+1)<=node->maxy))||
        ((*(tris_array+b+4)>=node->miny)&&(*(tris_array+b+4)<=node->maxy))||
        ((*(tris_array+b+7)>=node->miny)&&(*(tris_array+b+7)<=node->maxy))) c=2;
   }
   // test z hodnot vrcholov
   if (c==2) {
    if (((*(tris_array+b+2)>=node->minz)&&(*(tris_array+b+2)<=node->maxz))||
        ((*(tris_array+b+5)>=node->minz)&&(*(tris_array+b+5)<=node->maxz))||
        ((*(tris_array+b+8)>=node->minz)&&(*(tris_array+b+8)<=node->maxz))) c=3;
   }
   // ake je trojuholnik v liste, zvysi sa pocet trojuholnikov listu
   if (c==3) node->node_tris_num++;

   b+=9; // dalsi trojuholnik
  }

  //fprintf(stderr,"lists tris num: %u\n",node->node_tris_num);

  if (node->node_tris_num!=0) { // v liste budu trojuholniky
   node->node_tris=(GLfloat *) malloc(node->node_tris_num*9*sizeof(GLfloat));
   if (node->node_tris==NULL) {
    fprintf(stderr,"Error allocating memory for node_tris!\n"); return(1);
   }

   b=0; d=0;
   for (a=0;a<tris_num;a++) {
    c=0;
    // zistenie, ci je trojuholnik aspon 1 vrcholom v liste
    // test x hodnot vrcholov
    if (((*(tris_array+b)  >=node->minx)&&(*(tris_array+b)  <=node->maxx))||
        ((*(tris_array+b+3)>=node->minx)&&(*(tris_array+b+3)<=node->maxx))||
        ((*(tris_array+b+6)>=node->minx)&&(*(tris_array+b+6)<=node->maxx))) c=1;
    // test y hodnot vrcholov
    if (c==1) {
     if (((*(tris_array+b+1)>=node->miny)&&(*(tris_array+b+1)<=node->maxy))||
         ((*(tris_array+b+4)>=node->miny)&&(*(tris_array+b+4)<=node->maxy))||
         ((*(tris_array+b+7)>=node->miny)&&(*(tris_array+b+7)<=node->maxy))) c=2;
    }
    // test z hodnot vrcholov
    if (c==2) {
     if (((*(tris_array+b+2)>=node->minz)&&(*(tris_array+b+2)<=node->maxz))||
         ((*(tris_array+b+5)>=node->minz)&&(*(tris_array+b+5)<=node->maxz))||
         ((*(tris_array+b+8)>=node->minz)&&(*(tris_array+b+8)<=node->maxz))) c=3;
    }
    // ake je trojuholnik v liste, pridam ho do pola
    if (c==3) {
     *(node->node_tris+d)  =*(tris_array+b);
     *(node->node_tris+d+1)=*(tris_array+b+1);
     *(node->node_tris+d+2)=*(tris_array+b+2);
     *(node->node_tris+d+3)=*(tris_array+b+3);
     *(node->node_tris+d+4)=*(tris_array+b+4);
     *(node->node_tris+d+5)=*(tris_array+b+5);
     *(node->node_tris+d+6)=*(tris_array+b+6);
     *(node->node_tris+d+7)=*(tris_array+b+7);
     *(node->node_tris+d+8)=*(tris_array+b+8);
     d+=9;
    };

    b+=9; // dalsi trojuholnik
   }
  }
  else { node_level--; return(1); } // list je potrebne vymazat

  node_level--; return(0);
 }

 node_level++;
 if (tris_add(node->node[0])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[0]->node_tris!=NULL) free(node->node[0]->node_tris); // zrusi sa pole trojuholnikov
  delete[] node->node[0]; node->node[0]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[1])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[1]->node_tris!=NULL) free(node->node[1]->node_tris); // zrusi sa pole trojuholnikov
  delete[] node->node[1]; node->node[1]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[2])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[2]->node_tris!=NULL) free(node->node[2]->node_tris); // zrusi sa pole trojuholnikov
  delete[] node->node[2]; node->node[2]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[3])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[3]->node_tris!=NULL) free(node->node[3]->node_tris); // zrusi sa pole trojuholnikov
  delete[] node->node[3]; node->node[3]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[4])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[4]->node_tris!=NULL) free(node->node[4]->node_tris); // zrusi sa pole trojuholnikov
  delete[] node->node[4]; node->node[4]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[5])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[5]->node_tris!=NULL) free(node->node[5]->node_tris); // zrusi sa pole trojuholnikov
  delete[] node->node[5]; node->node[5]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[6])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[6]->node_tris!=NULL) free(node->node[6]->node_tris); // zrusi sa pole trojuholnikov
  delete[] node->node[6]; node->node[6]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[7])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[7]->node_tris!=NULL) free(node->node[7]->node_tris); // zrusi sa pole trojuholnikov
  delete[] node->node[7]; node->node[7]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }

 node_level--; return(0);
}

int OctTree::aaa(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node!=NULL) {
  node->node_draw_bit=0;
 }

 if (node_level==2) { node_level--; return(0); }

 node_level++; aaa(node->node[0]);
 node_level++; aaa(node->node[1]);
 node_level++; aaa(node->node[2]);
 node_level++; aaa(node->node[3]);
 node_level++; aaa(node->node[4]);
 node_level++; aaa(node->node[5]);
 node_level++; aaa(node->node[6]);
 node_level++; aaa(node->node[7]);

 node_level--; return(0);
}

// rekurzivne vykreslenie trojuholnikov v listoch oktanoveho stromu ********
int OctTree::node_render(_tree_node *node) // rekurzivna funkcia!!!
{
 tests_num++;
 
 if (node!=NULL) {
  if (m_FCull.CubeInFrustum2(node->minx,node->maxx,
                             node->miny,node->maxy,
                             node->minz,node->maxz)) {
   node->node_draw_bit=1;
   //glVertexPointer(3,GL_FLOAT,0,node->node_tris);
   //glDrawArrays(GL_TRIANGLES,0,3*node->node_tris_num);
  }
  else { node->node_draw_bit=0; node_level--; return(0); }
 }

 if (node_level==2) { node_level--; return(0); }

 node_level++; node_render(node->node[0]);
 node_level++; node_render(node->node[1]);
 node_level++; node_render(node->node[2]);
 node_level++; node_render(node->node[3]);
 node_level++; node_render(node->node[4]);
 node_level++; node_render(node->node[5]);
 node_level++; node_render(node->node[6]);
 node_level++; node_render(node->node[7]);

 node_level--; return(0);
}

// rekurzivne vykreslenie trojuholnikov v listoch oktanoveho stromu ********
int OctTree::node_render1(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node!=NULL) {
  if (node->node_draw_bit==1) {
   if (node_level==2) {
    glVertexPointer(3,GL_FLOAT,0,node->node_tris);
    glDrawArrays(GL_TRIANGLES,0,3*node->node_tris_num);
   }
  }
  else { node_level--; return(0); }
 }

 if (node_level==2) { node_level--; return(0); }

 node_level++; node_render1(node->node[0]);
 node_level++; node_render1(node->node[1]);
 node_level++; node_render1(node->node[2]);
 node_level++; node_render1(node->node[3]);
 node_level++; node_render1(node->node[4]);
 node_level++; node_render1(node->node[5]);
 node_level++; node_render1(node->node[6]);
 node_level++; node_render1(node->node[7]);

 node_level--; return(0);
}

// vykreslenie oktanoveho stromu *******************************************
void OctTree::Otree_render()
{
 m_FCull.FrustumUpdate();

 node_level=0; aaa(oct_tree);

 tests_num=0;
 node_level=0; node_render(oct_tree);

 //fprintf(stderr,"tests num: %u\n",tests_num);

 //glLoadIdentity();
 //glRotatef(90.0f,1.0f,0.0f,0.0f);
 //glTranslatef(-500.0f,-1000.0f,500.0f);
 
 node_level=0; node_render1(oct_tree);
}
