// trieda pre pracu s oktanovym stromom

typedef struct __tree_node { // list oktanoveho stromu
 GLfloat minx,maxx,miny,maxy,minz,maxz; // steny listu (kocky) oktanoveho stromu
 __tree_node *node[8];                  // odkaz na 8 podlistov aktualneho listu
 GLfloat *node_tris;   // pole trojuholnikov priradenych aktualnemu listu
 GLuint node_tris_num; // pocet trojuholnikov aktualneho listu
 GLuint node_draw_bit;
} _tree_node;

class OctTree {
public:
 OctTree();          // konstruktor
 virtual ~OctTree(); // destruktor

 int Otree_create(GLfloat *vert,GLuint all_tris_num); // vytvorenie oktanoveho stromu
 void Otree_draw();                                   // vykreslenie oktanoveho stromu
 int Otree_destroy();                                 // zrusenie oktanoveho stromu
 void Otree_render();                                 // vykreslenie trojuholnikov stromu
private:
 _tree_node *oct_tree; // rodicovsky list oktanoveho stromu
 GLuint node_level;    // hlbka oktanoveho stromu
 GLuint del_level;     // hlbka oktanoveho stromu, v ktorej budu zmazane listy
 GLuint tests_num;     // pocet testov na viditelnost listov stromu

 int node_add(_tree_node *node);  // pridanie listu do oktanoveho stromu
 int node_draw(_tree_node *node); // rekurzivne vykreslenie stromu
 int node_del(_tree_node *node);  // rekurzivne zrusenie listov stromu

 int tris_add(_tree_node *node);     // pridanie trojuholnikov do listov oktanoveho stromu
                                     // pridava sa do poslednej urovne
 int node_render(_tree_node *node);  // vykreslenie trojuholnikov ulozenych v listoch oktanoveho stromu
                                     // kresli sa z poslednej urovne
 int node_render1(_tree_node *node);

 int aaa(_tree_node *node);

 GLfloat *tris_array; // ukazovatel na pole trojuholnikov
 GLuint tris_num;     // celkovy pocet trojuholnikov

 GLuint a,b,c,d;            // pomocne premenne
 GLfloat x1,x2,y1,y2,z1,z2; // pomocne premenne

 GLuint alloc_mem; // pocitadlo alokovanej pamate
 GLuint free_mem;  // pocitadlo uvolnenej pamate 
};

