// vlastne funkcie pre pracu s BMP suborom
#include "BMPImage.h"

// trieda pre pracu s terenom
class glTerrain {
public:
 glTerrain();
 virtual ~glTerrain();

 GLuint all_triangles;  // pocitadlo vsetkych trojuholnikov
 GLuint cull_triangles; // pocitadlo orezanych trojuholnikov

 int terrain_create(unsigned char *bmp_data);
 GLfloat *terrain_getTriangles(void);
 GLfloat *terrain_getTriangles1(void);
 GLfloat *terrain_getNormals(void);
 GLfloat *terrain_getNormals1(void);
 GLfloat *terrain_getTexCoords(void);
 GLfloat *terrain_getTexCoords1(void);
 void terrain_render(GLuint tris_num);
 void normals_render(GLuint tris_num);
 int texture_terrain(TEXTURE tt,unsigned char *hf);
private:
 GLfloat tx,ty;              // pomocne premenne
 GLfloat ta,tb,tc;           // pomocne premenne
 GLuint t1,t2,t3,t4;         // pomocne premenne
 GLfloat n1,n2,n3;           // pre vypocet normal
 GLfloat q,w,e,r;            // pomocne premenne

 GLuint a,b,s,d,f;             // pomocne premenne

 unsigned char* height_map;       // pole s informaciami o vyske
 int height_map_w,height_map_h;	  // velkost obrazka vyskovej mapy
 TEXTURE texture_map;             // pole s informaciami o texture
 GLuint terrain_texture;          // textura terenu

 float scale_height; // mierka vysky

 GLfloat *vertex,*vertex1;       // vrcholy terenu
 GLfloat *normal,*normal1;       // normaly
 GLfloat *texcoords,*texcoords1; // koordinaty textur
 GLfloat *colors;          // farby pre kazdy vrchol
 GLfloat *fog;             // pre kazdy vrchol sila hmly z intervalu <0,1>

 CBMPImage bmp_img;        // instancia triedy CBMPImage
};

